/** YBJSBridge对象由native端注入到js中，不需要放到jssdk中；YBJSBridge是js和native方法调用的桥接对象*/
!function() {
        if(window.YBJSBridge) {
            return;
        }
        window.YBJSBridge = {
            msgCallbackMap : {},
            eventCallMap : {},

            /*
            * js调用native
            * action：方法名，字符串类型
            * params：传递参数，object类型
            * callback: 回调，function类型
            * */
            invoke : function (action, params, callback) {
                var msgBody = {};
                msgBody.action = action;
                msgBody.params = params;
                if (callback && typeof (callback) === 'function') {
                    var callbackId = "__ybcb" + (+new Date) + Math.random();
                    this.msgCallbackMap[callbackId] = callback;
                    msgBody.callbackId = callbackId;
                }

                // js调用oc，可判断系统，对iOS和安卓分开处理，TODO
        //        window.webkit.messageHandlers.ybJSBridge.postMessage(msgBody);// iOS调用方式
                prompt('ybjscall://'+JSON.stringify(msgBody));// Android调用方式：通过拦截prompt调用
            },

            /*
            * js调用native的回调触发器（由native端在合适的时机调用）
            * callbackId：回调id
            * resultjson：传递参数，json字符串
            * */
            invokeCallback : function (callbackId, resultjson) {
                var callback = this.msgCallbackMap[callbackId];
                if (callback && typeof (callback) === 'function') {
                    var resultObj = resultjson ? JSON.parse(resultjson) : {};
                    callback(resultObj);
                }
            },

            /*
            * js注册给native调用的方法
            * eventName：给native调用的方法名
            * handler：native调用js方法具体实现
            * */
            on : function (eventName, handler) {
                if (handler !== undefined) {
                    this.eventCallMap[eventName] = handler;
                }
            },

            /*
            * native调用js方法触发器
            * eventName：方法名
            * resultjson：传递参数，json字符串
            * */
            eventDispatcher : function (eventName, resultjson) {
                var handler = this.eventCallMap[eventName];
                if (handler && typeof (handler) === 'function') {
                    var resultObj = resultjson ? JSON.parse(resultjson) : {};
                    var returnData = handler(resultObj);
                    return returnData;
                }
            },

            test : function(){
                alert("test");
            }

        };
        var event = window.document.createEvent('Events');
        event.initEvent('YBJSBridgeReady');
        event.bridge = YBJSBridge;
        window.document.dispatchEvent(event);
    }();
